unit uFrmMain;

interface

uses
  System.SysUtils, Vcl.Forms, System.Classes, WEBLib.Graphics, WEBLib.Forms, WEBLib.Dialogs,
  Vcl.StdCtrls, WEBLib.StdCtrls, Vcl.Controls, WEBLib.Controls, WEBLib.ExtCtrls,
  uSubForm1, uSubForm2, WEBLib.Buttons;

type
  TFrmMain = class(TWebForm)
    txtSampleText: TWebEdit;
    lbTextsMain: TWebListBox;
    WebLabel1: TWebLabel;
    btCreateSubF1: TWebButton;
    HostPanel1: TWebPanel;
    btTransferSet: TWebButton;
    btTransferGet: TWebButton;
    WebButton2: TWebButton;
    WebBitBtn1: TWebBitBtn;
    WebLabel2: TWebLabel;
    WebLabel3: TWebLabel;
    HostPanel2: TWebPanel;
    procedure btCreateSubF1Click(Sender: TObject);
    procedure btRemoveSubFormClick(Sender: TObject);
    procedure btTransferSetClick(Sender: TObject);
    procedure btCreateSubF2Click(Sender: TObject);
    procedure WebFormCreate(Sender: TObject);
    procedure WebBitBtn1Click(Sender: TObject);
    procedure btTransferGetClick(Sender: TObject);
    procedure WebButton2Click(Sender: TObject);
  public
    frm1,frm2: TWebForm;
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.dfm}

uses
  web;

procedure TFrmMain.btCreateSubF1Click(Sender: TObject);

  procedure AfterCreate2(AForm: TObject);
  begin
    console.log('after create 2');
  end;

  procedure AfterCreate1(AForm: TObject);
  begin
    if Assigned(frm1) and (frm1 is TSubForm1) then
      ( frm1 as TSubForm1 ).lbTexts.Items.Assign(lbTextsMain.Items);


      frm2 :=  TSubForm2.CreateNew(HostPanel2.ElementID, @AfterCreate2);
      btTransferGet.Enabled := true;
      btTransferSet.Enabled := true;

  end;



begin
  // destroy possible old form
  if Assigned(frm1) then
    frm1.Close;

  if Assigned(frm2) then
    frm2.Close;

  frm1 :=  TSubForm1.CreateNew(HostPanel1.ElementID, @AfterCreate1);
  btTransferGet.Enabled := true;
  btTransferSet.Enabled := true;


end;

procedure TFrmMain.btRemoveSubFormClick(Sender: TObject);
begin
  // destroy possible old form
  if Assigned(frm1) then
  begin
    frm1.Close;
    frm1 := nil;
  end;

  btTransferGet.Enabled := false;
  btTransferSet.Enabled := false;
end;

procedure TFrmMain.btTransferSetClick(Sender: TObject);
begin
  if Assigned(frm1) and (frm1 is TSubForm1) then
    ( frm1 as TSubForm1 ).lbTexts.Items.Assign(lbTextsMain.Items);
end;

procedure TFrmMain.btCreateSubF2Click(Sender: TObject);
begin
  // destroy possible old form
  if Assigned(frm2) then
    frm2.Close;

  frm2 :=  TSubForm2.CreateNew(HostPanel2.ElementID, nil);
  btTransferGet.Enabled := false;
  btTransferSet.Enabled := false;
end;

procedure TFrmMain.WebBitBtn1Click(Sender: TObject);
begin
   lbTextsMain.Items.Add(txtSampleText.Text);
end;

procedure TFrmMain.btTransferGetClick(Sender: TObject);
begin
  if Assigned(frm2) and (frm2 is TSubForm1) then
    lbTextsMain.Items.Assign((frm2 as TSubForm1).lbTexts.Items);
end;

procedure TFrmMain.WebButton2Click(Sender: TObject);
begin
  lbTextsMain.Items.Clear;
end;

procedure TFrmMain.WebFormCreate(Sender: TObject);
begin
  frm1 := nil;
  frm2 := nil;
end;

end.
